Subject: [core] block-03 parallel usage example

From: Guido Moritz <[email-masked]>
Date: Thu, 5 May 2011 15:07:42 +0200

Dear block-03 authors,

I read through the block-03 draft and to be honest, section 2 (especially
2.2) is quite hard to follow... Very much compressed information. 

As far as I see, there is still a possibility to use blockwise transfer for
both request and response at the same time. May we have an example of this
in the draft?

As far as I understand, there are two different CoAP message exchanges
required:
(1) The first message exchange using B1 in the REQ to indicate which block
of the REQ is carried in the payload. The ACK is using B1 to ACK the
according block, setting M=1.
(2) Another message exchange as RES with B2, indicating the current block in
the RES and B1 to ACK, with M bit of B1 to ignore. I am not sure if B1 of
block-03 is allowed to be used for this case?

I tried to put this in a figure. Nevertheless, since POST still has no
response code carrying payload (see my mail a few minutes ago), I just used
2.00 OK for this. Comments are welcome...

   CLIENT                                                     SERVER
     |                                                          |
     | CON [MID=1234], POST, /options, v17, 1/0/1/128    ------> |
     |                                                          |
     | <------   ACK [MID=1234], 1/0/1/128
|
     |                                                          |
     | CON [MID=1235], POST, /options, v17, 1/1/1/128    ------> |
     |                                                          |
     | <------   ACK [MID=1235], 1/1/1/128
|
     |                                                          |
     | CON [MID=1236], POST, /options, v17, 1/2/0/128    ------> |
     |                                                          |
     | <------   ACK [MID=1236], 1/2/1/128
|
     |                                                          |
              ...time passes...
     |                                                          |
     | <------   CON [MID=2345], 2.00 OK, v17, 2/0/1/128 |
     |                                                          |
     | ACK [MID=2345], 1/0/x/128
------>  |
     |                                                          |
     | <------   CON [MID=2346], 2.00 OK, v17, 2/1/1/128 |
     |                                                          |
     | ACK [MID=2346], 1/1/x/128
------>  |
     |                                                          |
     | <------   CON [MID=2347], 2.00 OK, v17, 2/2/0/128 |
     |                                                          |
     | ACK [MID=2347], 1/2/x/128
------>  |

Best,
Guido